## range-v3 0.4.0

=== CMakeLists.txt ===
# Copyright Eric Niebler 2014
# Copyright Gonzalo Brito Gadeschi 2014, 2017
# Copyright Louis Dionne 2015
# Copyright Casey Carter 2016
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE.md or copy at http://boost.org/LICENSE_1_0.txt)

cmake_minimum_required(VERSION 3.6)
get_directory_property(is_subproject PARENT_DIRECTORY)

project(Range-v3 CXX)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON) # Export compilation data-base

add_library(meta INTERFACE)
target_include_directories(meta INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>)
target_include_directories(meta SYSTEM INTERFACE $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>)

add_library(range-v3 INTERFACE)
target_include_directories(range-v3 INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>)
target_include_directories(range-v3 SYSTEM INTERFACE $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>)
target_link_libraries(range-v3 INTERFACE meta)

include(CTest) # invokes enable_testing() and defines BUILD_TESTING variable, defaulting to ON
include(TestHeaders)
include(ranges_options)
include(ranges_env)
include(ranges_flags)

# Test for <thread>
try_compile(RANGE_V3_TRY_THREAD ${CMAKE_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/thread_test_code.cpp)

# Test for coroutine TS support
include(CheckCXXSourceCompiles)

file(READ "${CMAKE_CURRENT_SOURCE_DIR}/cmake/coro_test_code.cpp" RANGE_V3_CORO_TEST_CODE)
set(CMAKE_REQUIRED_FLAGS "-fcoroutines-ts")
check_cxx_source_compiles("${RANGE_V3_CORO_TEST_CODE}" RANGE_V3_HAS_FCOROUTINES_TS)
unset(CMAKE_REQUIRED_FLAGS)

if(RANGE_V3_DOCS)
  add_subdirectory(doc)
endif()

if(RANGE_V3_TESTS)
  add_subdirectory(test)
endif()

if(RANGE_V3_EXAMPLES)
  add_subdirectory(example)
endif()

if(RANGE_V3_PERF)
  add_subdirectory(perf)
endif()

# Test all headers
file(GLOB_RECURSE RANGE_V3_PUBLIC_HEADERS
                  RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/include"
                  "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")

# Add header files as sources to fix MSVS 2017 not finding source during debugging
file(GLOB_RECURSE RANGE_V3_PUBLIC_HEADERS_ABSOLUTE
                  "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")

include(TestHeaders)
if(RANGE_V3_HEADER_CHECKS)
  add_custom_target(headers ALL SOURCES ${RANGE_V3_PUBLIC_HEADERS_ABSOLUTE})
else()
  add_custom_target(headers SOURCES ${RANGE_V3_PUBLIC_HEADERS_ABSOLUTE})
endif()
generate_standalone_header_tests(EXCLUDE_FROM_ALL MASTER_TARGET headers HEADERS ${RANGE_V3_PUBLIC_HEADERS})

# Grab the range-v3 version numbers:
include(${CMAKE_CURRENT_SOURCE_DIR}/Version.cmake)
set(RANGE_V3_VERSION ${RANGE_V3_MAJOR}.${RANGE_V3_MINOR}.${RANGE_V3_PATCHLEVEL})

# Try to build a new version.hpp
configure_file(version.hpp.in include/range/v3/version.hpp @ONLY)
file(STRINGS ${CMAKE_CURRENT_BINARY_DIR}/include/range/v3/version.hpp RANGE_V3_OLD_VERSION_HPP)
file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/include/range/v3/version.hpp RANGE_V3_NEW_VERSION_HPP)

# If the new version.hpp is materially different from the one in the source
# directory, update it, commit, and tag.
if(NOT RANGE_V3_NEW_VERSION_HPP STREQUAL RANGE_V3_OLD_VERSION_HPP)
  # Check that README.md and Version.cmake are the only changed file:
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" status --porcelain -uno
    OUTPUT_VARIABLE RANGE_V3_GIT_STATUS
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  string(REPLACE "\n" ";"  RANGE_V3_GIT_STATUS ${RANGE_V3_GIT_STATUS})
  if (NOT "x${RANGE_V3_GIT_STATUS}" STREQUAL "x M README.md; M Version.cmake")
    message(FATAL_ERROR "Cannot update version.hpp: range-v3 source directory has a dirty status")
  endif()
  file(
    COPY ${CMAKE_CURRENT_BINARY_DIR}/include/range/v3/version.hpp
    DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}/include/range/v3
  )
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" add -u
  )
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" commit -m "${RANGE_V3_VERSION}"
  )
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" tag -f -a "${RANGE_V3_VERSION}" -m "${RANGE_V3_VERSION}"
  )
  find_program(CONAN_EXECUTABLE NAMES conan conan.exe)
  if (NOT "x${CONAN_EXECUTABLE}" STREQUAL "xCONAN_EXECUTABLE-NOTFOUND")
    message("Exporting conanfile for new version")
    execute_process(
      COMMAND ${CONAN_EXECUTABLE} create . range-v3/${RANGE_V3_VERSION}@ericniebler/stable
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    )
  endif()
  message("Version updated to ${RANGE_V3_VERSION}. Don't forget to:")
  message("  git push origin <feature-branch>")
  message("and (after that is merged to master) then:")
  message("  conan create ${CMAKE_CURRENT_SOURCE_DIR} range-v3/${RANGE_V3_VERSION}@ericniebler/stable")
  message("  conan upload --all range-v3/${RANGE_V3_VERSION}@ericniebler/stable")
endif()

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/range-v3-config-version.cmake
  VERSION ${RANGE_V3_VERSION}
  COMPATIBILITY ExactVersion
)

install(TARGETS meta range-v3 EXPORT range-v3-targets DESTINATION lib)
install(EXPORT range-v3-targets FILE range-v3-config.cmake DESTINATION lib/cmake/range-v3)
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/range-v3-config-version.cmake
  DESTINATION lib/cmake/range-v3)
install(DIRECTORY include/ DESTINATION include FILES_MATCHING PATTERN "*.hpp")

=== doc/CMakeLists.txt ===
#=============================================================================
# Setup the documentation
#=============================================================================
if (NOT DOXYGEN_FOUND)
    message(STATUS
    "Doxygen not found; the 'doc' and 'gh-pages.{clean,copy,update}' targets "
    "will be unavailable.")
    return()
endif()

configure_file(Doxyfile.in Doxyfile @ONLY)
add_custom_target(doc.check
    COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
    COMMENT "Running Doxygen to validate the documentation"
    VERBATIM
)

# if (NOT TARGET benchmarks)
#     message(STATUS
#         "The 'benchmarks' target is not available; the 'doc' and "
#         "'gh-pages.{clean,copy,update}' targets will be unavailable. "
#         "The 'doc.check' target can still be used to generate the "
#         "documentation to check for errors/warnings.")
#     return()
# endif()

add_custom_target(doc
    COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
    COMMENT "Generating API documentation with Doxygen"
#     DEPENDS benchmarks
    VERBATIM
)

if (NOT GIT_FOUND)
    message(STATUS
    "Git was not found; the 'gh-pages.{clean,copy,update}' targets "
    "will be unavailable.")
    return()
endif()

add_custom_target(gh-pages.clean
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_LIST_DIR}/clean-gh-pages.cmake
    COMMAND ${CMAKE_COMMAND} -E remove_directory search
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/gh-pages
    COMMENT "Cleaning up doc/gh-pages"
    VERBATIM
)

add_custom_target(gh-pages.copy
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_BINARY_DIR}/html ${CMAKE_CURRENT_LIST_DIR}/gh-pages
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/gh-pages
    COMMENT "Copying the documentation from ${CMAKE_CURRENT_BINARY_DIR}/html to doc/gh-pages"
    DEPENDS doc gh-pages.clean
    VERBATIM
)

execute_process(
    COMMAND ${GIT_EXECUTABLE} -C ${CMAKE_SOURCE_DIR} rev-parse --short HEAD
    OUTPUT_VARIABLE RANGE_V3_GIT_SHORT_SHA
    OUTPUT_STRIP_TRAILING_WHITESPACE
)

add_custom_target(gh-pages.update
    COMMAND ${GIT_EXECUTABLE} add --all .
    COMMAND ${GIT_EXECUTABLE} commit -m "Update to ${RANGE_V3_GIT_SHORT_SHA}"
    WORKING_DIRECTORY ${CMAKE_CURRENT_LIST_DIR}/gh-pages
    COMMENT "Updating the gh-pages branch with freshly built documentation"
    DEPENDS gh-pages.copy
    VERBATIM
)

=== example/CMakeLists.txt ===
# examples use a less draconian set of compiler warnings
ranges_append_flag(RANGES_HAS_WNO_MISSING_BRACES -Wno-missing-braces)
ranges_append_flag(RANGES_HAS_WNO_SHORTEN_64_TO_32 -Wno-shorten-64-to-32)
ranges_append_flag(RANGES_HAS_WNO_GLOBAL_CONSTRUCTORS -Wno-global-constructors)

add_executable(comprehensions comprehensions.cpp)
target_link_libraries(comprehensions range-v3)
add_test(example.comprehensions, comprehensions)

add_executable(hello hello.cpp)
target_link_libraries(hello range-v3)
add_test(example.hello, hello)

add_executable(count count.cpp)
target_link_libraries(count range-v3)
add_test(example.count, count)

add_executable(count_if count_if.cpp)
target_link_libraries(count_if range-v3)
add_test(example.count_if, count_if)

add_executable(any_all_none_of any_all_none_of.cpp)
target_link_libraries(any_all_none_of range-v3)
add_test(example.any_all_none_of, any_all_none_of)

add_executable(for_each_sequence for_each_sequence.cpp)
target_link_libraries(for_each_sequence range-v3)
add_test(example.for_each_sequence, for_each_sequence)

add_executable(for_each_assoc for_each_assoc.cpp)
target_link_libraries(for_each_assoc range-v3)
add_test(example.for_each_assoc, for_each_assoc)

add_executable(is_sorted is_sorted.cpp)
target_link_libraries(is_sorted range-v3)
add_test(example.is_sorted, is_sorted)

add_executable(find find.cpp)
target_link_libraries(find range-v3)
add_test(example.find, find)

# add_executable(fibonacci fibonacci.cpp)
# target_link_libraries(fibonacci range-v3)
# add_test(example.fibonacci, fibonacci)

# Guarded with a variable because the calendar example causes gcc to puke.
if(RANGES_BUILD_CALENDAR_EXAMPLE)
    set(Boost_USE_STATIC_LIBS        ON)
    set(Boost_USE_MULTITHREADED     OFF)
    set(Boost_USE_STATIC_RUNTIME    OFF)
    find_package(Boost 1.59.0 COMPONENTS date_time program_options)

    if (Boost_FOUND)
        include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
        add_executable(calendar calendar.cpp)
        target_link_libraries(calendar range-v3)
        target_link_libraries(calendar ${Boost_LIBRARIES})
        message ("boost: ${Boost_LIBRARY_DIRS}")
        target_compile_definitions(calendar PUBLIC BOOST_NO_AUTO_PTR)
        target_compile_options(calendar PRIVATE -std=gnu++14)
        set_target_properties(calendar PROPERTIES LINK_FLAGS "-L${Boost_LIBRARY_DIRS}")
    endif()
endif()

=== test/action/CMakeLists.txt ===
rv3_add_test(test.act.concepts act.concepts cont_concepts.cpp)
rv3_add_test(test.act.drop act.drop drop.cpp)
rv3_add_test(test.act.drop_while act.drop_while drop_while.cpp)
rv3_add_test(test.act.insert act.insert insert.cpp)
rv3_add_test(test.act.join act.join join.cpp)
rv3_add_test(test.act.push_front act.push_front push_front.cpp)
rv3_add_test(test.act.push_back act.push_back push_back.cpp)
rv3_add_test(test.act.remove_if act.remove_if remove_if.cpp)
rv3_add_test(test.act.reverse act.reverse reverse.cpp)
rv3_add_test(test.act.shuffle act.shuffle shuffle.cpp)
rv3_add_test(test.act.slice act.slice slice.cpp)
rv3_add_test(test.act.sort act.sort sort.cpp)
rv3_add_test(test.act.split act.split split.cpp)
rv3_add_test(test.act.stable_sort act.stable_sort stable_sort.cpp)
rv3_add_test(test.act.stride act.stride stride.cpp)
rv3_add_test(test.act.take act.take take.cpp)
rv3_add_test(test.act.take_while act.take_while take_while.cpp)
rv3_add_test(test.act.transform act.transform transform.cpp)
rv3_add_test(test.act.unique act.unique unique.cpp)

=== test/algorithm/CMakeLists.txt ===
rv3_add_test(test.alg.adjacent_find alg.adjacent_find adjacent_find.cpp)
rv3_add_test(test.alg.all_of alg.all_of all_of.cpp)
rv3_add_test(test.alg.any_of alg.any_of any_of.cpp)
rv3_add_test(test.alg.none_of alg.none_of none_of.cpp)
rv3_add_test(test.alg.binary_search alg.binary_search binary_search.cpp)
rv3_add_test(test.alg.copy alg.copy copy.cpp)
rv3_add_test(test.alg.copy_backward alg.copy_backward copy_backward.cpp)
rv3_add_test(test.alg.count alg.count count.cpp)
rv3_add_test(test.alg.count_if alg.count_if count_if.cpp)
rv3_add_test(test.alg.equal alg.equal equal.cpp)
rv3_add_test(test.alg.equal_range alg.equal_range equal_range.cpp)
rv3_add_test(test.alg.fill alg.fill fill.cpp)
rv3_add_test(test.alg.find alg.find find.cpp)
rv3_add_test(test.alg.find_end alg.find_end find_end.cpp)
rv3_add_test(test.alg.find_if alg.find_if find_if.cpp)
rv3_add_test(test.alg.find_first_of alg.find_first_of find_first_of.cpp)
rv3_add_test(test.alg.for_each alg.for_each for_each.cpp)
rv3_add_test(test.alg.for_each_n alg.for_each_n for_each_n.cpp)
rv3_add_test(test.alg.generate alg.generate generate.cpp)
rv3_add_test(test.alg.generate_n alg.generate_n generate_n.cpp)
rv3_add_test(test.alg.includes alg.includes includes.cpp)
rv3_add_test(test.alg.inplace_merge alg.inplace_merge inplace_merge.cpp)
rv3_add_test(test.alg.is_heap1 alg.is_heap1 is_heap1.cpp)
rv3_add_test(test.alg.is_heap2 alg.is_heap2 is_heap2.cpp)
rv3_add_test(test.alg.is_heap3 alg.is_heap3 is_heap3.cpp)
rv3_add_test(test.alg.is_heap4 alg.is_heap4 is_heap4.cpp)
rv3_add_test(test.alg.is_heap_until1 alg.is_heap_until1 is_heap_until1.cpp)
rv3_add_test(test.alg.is_heap_until2 alg.is_heap_until2 is_heap_until2.cpp)
rv3_add_test(test.alg.is_heap_until3 alg.is_heap_until3 is_heap_until3.cpp)
rv3_add_test(test.alg.is_heap_until4 alg.is_heap_until4 is_heap_until4.cpp)
rv3_add_test(test.alg.is_partitioned alg.is_partitioned is_partitioned.cpp)
rv3_add_test(test.alg.is_permutation alg.is_permutation is_permutation.cpp)
rv3_add_test(test.alg.is_sorted_until alg.is_sorted_until is_sorted_until.cpp)
rv3_add_test(test.alg.is_sorted alg.is_sorted is_sorted.cpp)
rv3_add_test(test.alg.lexicographical_compare alg.lexicographical_compare lexicographical_compare.cpp)
rv3_add_test(test.alg.lower_bound alg.lower_bound lower_bound.cpp)
rv3_add_test(test.alg.make_heap alg.make_heap make_heap.cpp)
rv3_add_test(test.alg.max alg.max max.cpp)
rv3_add_test(test.alg.max_element alg.max_element max_element.cpp)
rv3_add_test(test.alg.merge alg.merge merge.cpp)
rv3_add_test(test.alg.min alg.min min.cpp)
rv3_add_test(test.alg.min_element alg.min_element min_element.cpp)
rv3_add_test(test.alg.minmax alg.minmax minmax.cpp)
rv3_add_test(test.alg.minmax_element alg.minmax_element minmax_element.cpp)
rv3_add_test(test.alg.mismatch alg.mismatch mismatch.cpp)
rv3_add_test(test.alg.move alg.move move.cpp)
rv3_add_test(test.alg.move_backward alg.move_backward move_backward.cpp)
rv3_add_test(test.alg.next_permutation alg.next_permutation next_permutation.cpp)
rv3_add_test(test.alg.nth_element alg.nth_element nth_element.cpp)
rv3_add_test(test.alg.partial_sort alg.partial_sort partial_sort.cpp)
rv3_add_test(test.alg.partial_sort_copy alg.partial_sort_copy partial_sort_copy.cpp)
rv3_add_test(test.alg.partition alg.partition partition.cpp)
rv3_add_test(test.alg.partition_copy alg.partition_copy partition_copy.cpp)
rv3_add_test(test.alg.partition_point alg.partition_point partition_point.cpp)
rv3_add_test(test.alg.pop_heap alg.pop_heap pop_heap.cpp)
rv3_add_test(test.alg.prev_permutation alg.prev_permutation prev_permutation.cpp)
rv3_add_test(test.alg.push_heap alg.push_heap push_heap.cpp)
rv3_add_test(test.alg.remove alg.remove remove.cpp)
rv3_add_test(test.alg.remove_copy alg.remove_copy remove_copy.cpp)
rv3_add_test(test.alg.remove_copy_if alg.remove_copy_if remove_copy_if.cpp)
rv3_add_test(test.alg.remove_if alg.remove_if remove_if.cpp)
rv3_add_test(test.alg.replace alg.replace replace.cpp)
rv3_add_test(test.alg.replace_copy alg.replace_copy replace_copy.cpp)
rv3_add_test(test.alg.replace_copy_if alg.replace_copy_if replace_copy_if.cpp)
rv3_add_test(test.alg.replace_if alg.replace_if replace_if.cpp)
rv3_add_test(test.alg.reverse alg.reverse reverse.cpp)
rv3_add_test(test.alg.reverse_copy alg.reverse_copy reverse_copy.cpp)
rv3_add_test(test.alg.rotate alg.rotate rotate.cpp)
rv3_add_test(test.alg.rotate_copy alg.rotate_copy rotate_copy.cpp)
rv3_add_test(test.alg.sample alg.sample sample.cpp)
rv3_add_test(test.alg.search alg.search search.cpp)
rv3_add_test(test.alg.search_n alg.search_n search_n.cpp)
rv3_add_test(test.alg.set_difference1 alg.set_difference1 set_difference1.cpp)
rv3_add_test(test.alg.set_difference2 alg.set_difference2 set_difference2.cpp)
rv3_add_test(test.alg.set_difference3 alg.set_difference3 set_difference3.cpp)
rv3_add_test(test.alg.set_difference4 alg.set_difference4 set_difference4.cpp)
rv3_add_test(test.alg.set_difference5 alg.set_difference5 set_difference5.cpp)
rv3_add_test(test.alg.set_difference6 alg.set_difference6 set_difference6.cpp)
rv3_add_test(test.alg.set_intersection1 alg.set_intersection1 set_intersection1.cpp)
rv3_add_test(test.alg.set_intersection2 alg.set_intersection2 set_intersection2.cpp)
rv3_add_test(test.alg.set_intersection3 alg.set_intersection3 set_intersection3.cpp)
rv3_add_test(test.alg.set_intersection4 alg.set_intersection4 set_intersection4.cpp)
rv3_add_test(test.alg.set_intersection5 alg.set_intersection5 set_intersection5.cpp)
rv3_add_test(test.alg.set_intersection6 alg.set_intersection6 set_intersection6.cpp)
rv3_add_test(test.alg.set_symmetric_difference1 alg.set_symmetric_difference1 set_symmetric_difference1.cpp)
rv3_add_test(test.alg.set_symmetric_difference2 alg.set_symmetric_difference2 set_symmetric_difference2.cpp)
rv3_add_test(test.alg.set_symmetric_difference3 alg.set_symmetric_difference3 set_symmetric_difference3.cpp)
rv3_add_test(test.alg.set_symmetric_difference4 alg.set_symmetric_difference4 set_symmetric_difference4.cpp)
rv3_add_test(test.alg.set_symmetric_difference5 alg.set_symmetric_difference5 set_symmetric_difference5.cpp)
rv3_add_test(test.alg.set_symmetric_difference6 alg.set_symmetric_difference6 set_symmetric_difference6.cpp)
rv3_add_test(test.alg.set_union1 alg.set_union1 set_union1.cpp)
rv3_add_test(test.alg.set_union2 alg.set_union2 set_union2.cpp)
rv3_add_test(test.alg.set_union3 alg.set_union3 set_union3.cpp)
rv3_add_test(test.alg.set_union4 alg.set_union4 set_union4.cpp)
rv3_add_test(test.alg.set_union5 alg.set_union5 set_union5.cpp)
rv3_add_test(test.alg.set_union6 alg.set_union6 set_union6.cpp)
rv3_add_test(test.alg.shuffle alg.shuffle shuffle.cpp)
rv3_add_test(test.alg.sort alg.sort sort.cpp)
rv3_add_test(test.alg.sort_heap alg.sort_heap sort_heap.cpp)
rv3_add_test(test.alg.stable_partition alg.stable_partition stable_partition.cpp)
rv3_add_test(test.alg.stable_sort alg.stable_sort stable_sort.cpp)
rv3_add_test(test.alg.swap_ranges alg.swap_ranges swap_ranges.cpp)
rv3_add_test(test.alg.transform alg.transform transform.cpp)
rv3_add_test(test.alg.unique alg.unique unique.cpp)
rv3_add_test(test.alg.unique_copy alg.unique_copy unique_copy.cpp)
rv3_add_test(test.alg.upper_bound alg.upper_bound upper_bound.cpp)
rv3_add_test(test.alg.sort_n_with_buffer alg.sort_n_with_buffer sort_n_with_buffer.cpp)

=== test/experimental/CMakeLists.txt ===
add_subdirectory(utility)
add_subdirectory(view)

=== test/numeric/CMakeLists.txt ===
rv3_add_test(test.num.accumulate num.accumulate accumulate.cpp)
rv3_add_test(test.num.adjacent_difference num.adjacent_difference adjacent_difference.cpp)
rv3_add_test(test.num.inner_product num.inner_product inner_product.cpp)
rv3_add_test(test.num.iota num.iota iota.cpp)
rv3_add_test(test.num.partial_sum num.partial_sum partial_sum.cpp)

=== test/utility/CMakeLists.txt ===
rv3_add_test(test.utility.basic_iterator utility.basic_iterator basic_iterator.cpp)
rv3_add_test(test.utility.concepts utility.concepts concepts.cpp)
rv3_add_test(test.utility.common_type utility.common_type common_type.cpp)
rv3_add_test(test.utility.functional utility.functional functional.cpp)
rv3_add_test(test.utility.iterator utility.iterator iterator.cpp)
rv3_add_test(test.utility.common_iterator utility.common_iterator common_iterator.cpp)
rv3_add_test(test.utility.reverse_iterator utility.reverse_iterator reverse_iterator.cpp)
rv3_add_test(test.utility.swap utility.swap swap.cpp)
rv3_add_test(test.utility.variant utility.variant variant.cpp)
rv3_add_test(test.utility.meta utility.meta meta.cpp)
rv3_add_test(test.utility.scope_exit utility.scope_exit scope_exit.cpp)

=== test/view/CMakeLists.txt ===
rv3_add_test(test.view.adjacent_remove_if view.adjacent_remove_if adjacent_remove_if.cpp)
rv3_add_test(test.view.all view.all all.cpp)
rv3_add_test(test.view.any_view view.any_view any_view.cpp)
rv3_add_test(test.view.bounded view.bounded bounded.cpp)
rv3_add_test(test.view.cartesian_product view.cartesian_product cartesian_product.cpp)
rv3_add_test(test.view.chunk view.chunk chunk.cpp)
rv3_add_test(test.view.concat view.concat concat.cpp)
rv3_add_test(test.view.const view.const const.cpp)
rv3_add_test(test.view.counted view.counted counted.cpp)
rv3_add_test(test.view.cycle view.cycle cycle.cpp)
rv3_add_test(test.view.delimit view.delimit delimit.cpp)
rv3_add_test(test.view.drop view.drop drop.cpp)
rv3_add_test(test.view.drop_exactly view.drop_exactly drop_exactly.cpp)
rv3_add_test(test.view.drop_while view.drop_while drop_while.cpp)
rv3_add_test(test.view.exclusive_scan view.exclusive_scan exclusive_scan.cpp)
rv3_add_test(test.view.generate view.generate generate.cpp)
rv3_add_test(test.view.generate_n view.generate_n generate_n.cpp)
rv3_add_test(test.view.group_by view.group_by group_by.cpp)
rv3_add_test(test.view.indirect view.indirect indirect.cpp)
rv3_add_test(test.view.intersperse view.intersperse intersperse.cpp)
rv3_add_test(test.view.iota view.iota iota.cpp)
rv3_add_test(test.view.join view.join join.cpp)
rv3_add_test(test.view.linear_distribute view.linear_distribute linear_distribute.cpp)
rv3_add_test(test.view.map view.map keys_value.cpp)
rv3_add_test(test.view.move view.move move.cpp)
rv3_add_test(test.view.partial_sum view.partial_sum partial_sum.cpp)
rv3_add_test(test.view.repeat view.repeat repeat.cpp)
rv3_add_test(test.view.remove_if view.remove_if remove_if.cpp)
rv3_add_test(test.view.replace view.replace replace.cpp)
rv3_add_test(test.view.replace_if view.replace_if replace_if.cpp)
rv3_add_test(test.view.reverse view.reverse reverse.cpp)
rv3_add_test(test.view.sample view.sample sample.cpp)
rv3_add_test(test.view.set_difference view.set_difference set_difference.cpp)
rv3_add_test(test.view.set_intersection view.set_intersection set_intersection.cpp)
rv3_add_test(test.view.set_symmetric_difference view.set_symmetric_difference set_symmetric_difference.cpp)
rv3_add_test(test.view.set_union view.set_union set_union.cpp)
rv3_add_test(test.view.slice view.slice slice.cpp)
rv3_add_test(test.view.sliding view.sliding sliding.cpp)
rv3_add_test(test.view.split view.split split.cpp)
rv3_add_test(test.view.stride view.stride stride.cpp)
rv3_add_test(test.view.tail view.tail tail.cpp)
rv3_add_test(test.view.take view.take take.cpp)
rv3_add_test(test.view.take_exactly view.take_exactly take_exactly.cpp)
rv3_add_test(test.view.take_while view.take_while take_while.cpp)
rv3_add_test(test.view.tokenize view.tokenize tokenize.cpp)
rv3_add_test(test.view.transform view.transform transform.cpp)
rv3_add_test(test.view.unique view.unique unique.cpp)
rv3_add_test(test.view.zip view.zip zip.cpp)

=== test/experimental/utility/CMakeLists.txt ===
rv3_add_test(test.generator generator generator.cpp)

=== test/experimental/view/CMakeLists.txt ===
rv3_add_test(test.view.shared view.shared shared.cpp)

=== debian/changelog ===
range-v3 (0.4.0-2) unstable; urgency=medium

  * Fix FTBFS with GCC 8.3.0 (closes: #926218).
    - Ignore false positive warning "maybe-uninitialized"
    - Rewrite the ranges_append_flag macro to avoid errors "unrecognized
      command line option".

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 27 Apr 2019 09:53:30 +0300

range-v3 (0.4.0-1) unstable; urgency=medium

  * New upstream release.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Wed, 14 Nov 2018 21:34:48 +0300

range-v3 (0.3.7-1) unstable; urgency=medium

  * New upstream release.
  * Bump standards version to 4.2.1, no changes for this.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Mon, 01 Oct 2018 08:49:19 +0300

=== debian/control ===
Source: range-v3
Section: libdevel
Priority: optional
Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper (>=11)
Build-Depends-Indep: cmake (>=3.6), doxygen-latex <!nodoc>
Standards-Version: 4.2.1
Rules-Requires-Root: no
Homepage: https://github.com/ericniebler/range-v3
Vcs-Git: https://salsa.debian.org/debian/range-v3.git
Vcs-Browser: https://salsa.debian.org/debian/range-v3

Package: librange-v3-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: librange-v3-doc
Description: range algorithms, views, and actions for C++11/14/17 - headers
 Range-v3 is a generic library that augments the existing standard library with
 facilities for working with ranges. A range can be loosely thought of a pair
 of iterators. This library provides a full implementation of all the standard
 algorithms with range-based overloads for convenience.
 .
 This package contains headers of the library.

Package: librange-v3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: range algorithms, views, and actions for C++11/14/17 - documentation
 Range-v3 is a generic library that augments the existing standard library with
 facilities for working with ranges. A range can be loosely thought of a pair
 of iterators. This library provides a full implementation of all the standard
 algorithms with range-based overloads for convenience.
 .
 This package ships HTML documentation of the library.

=== debian/rules ===
#!/usr/bin/make -f

# Skip false positive at test/container_conversion.cpp:39
# See https://bugs.debian.org/926218
export DEB_CXXFLAGS_MAINT_APPEND = -Wno-error=maybe-uninitialized

EXTRA_CMAKE_VARIABLES = \
	CMAKE_SKIP_INSTALL_ALL_DEPENDENCY=ON \
	RANGES_NATIVE=OFF \
	RANGES_VERBOSE_BUILD=ON

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

# Range-v3 is header library so we should make only online documentation unless
# the `nodoc` flag is specified.
override_dh_auto_build:
ifeq (,$(filter nodoc, $(DEB_BUILD_OPTIONS)))
	dh_auto_build -- doc
endif

# The `test` target doesn't compile tests by itself and fails if they aren't
# built before.
override_dh_auto_test:
ifeq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))
	dh_auto_build
	dh_auto_test
endif

## range-v3 0.9.1

=== CMakeLists.txt ===
# Copyright Eric Niebler 2014
# Copyright Gonzalo Brito Gadeschi 2014, 2017
# Copyright Louis Dionne 2015
# Copyright Casey Carter 2016
# Distributed under the Boost Software License, Version 1.0.
# (See accompanying file LICENSE.md or copy at http://boost.org/LICENSE_1_0.txt)

cmake_minimum_required(VERSION 3.6)
get_directory_property(is_subproject PARENT_DIRECTORY)

if(NOT is_subproject)
    set(is_standalone YES)
else()
    set(is_standalone NO)
endif()

project(Range-v3 CXX)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON) # Export compilation data-base
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

add_library(meta INTERFACE)
target_include_directories(meta INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>)
target_include_directories(meta SYSTEM INTERFACE $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>)
target_compile_options(meta INTERFACE $<$<CXX_COMPILER_ID:MSVC>:/permissive->)

add_library(concepts INTERFACE)
target_include_directories(concepts INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>)
target_include_directories(concepts SYSTEM INTERFACE $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>)
target_compile_options(concepts INTERFACE $<$<CXX_COMPILER_ID:MSVC>:/permissive- /experimental:preprocessor /wd5105>)
target_link_libraries(concepts INTERFACE meta)

add_library(range-v3 INTERFACE)
target_include_directories(range-v3 INTERFACE $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include/>)
target_include_directories(range-v3 SYSTEM INTERFACE $<INSTALL_INTERFACE:$<INSTALL_PREFIX>/include>)
target_compile_options(range-v3 INTERFACE $<$<CXX_COMPILER_ID:MSVC>:/permissive->)
target_link_libraries(range-v3 INTERFACE concepts meta)

function(rv3_add_test TESTNAME EXENAME FIRSTSOURCE)
  add_executable(${EXENAME} ${FIRSTSOURCE} ${ARGN})
  target_link_libraries(${EXENAME} range-v3)
  add_test(${TESTNAME} ${EXENAME})
endfunction(rv3_add_test)

include(ranges_options)
include(ranges_env)
include(ranges_flags)

if(RANGE_V3_DOCS)
  add_subdirectory(doc)
endif()

if(RANGE_V3_TESTS)
  include(CTest)
  add_subdirectory(test)
endif()

if(RANGE_V3_EXAMPLES)
  add_subdirectory(example)
endif()

if(RANGE_V3_PERF)
  add_subdirectory(perf)
endif()

# Add header files as sources to fix MSVS 2017 not finding source during debugging
file(GLOB_RECURSE RANGE_V3_PUBLIC_HEADERS_ABSOLUTE
                  "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
add_custom_target(headers SOURCES ${RANGE_V3_PUBLIC_HEADERS_ABSOLUTE})
set_target_properties(headers PROPERTIES FOLDER "header")

# Test all headers
if(RANGE_V3_HEADER_CHECKS)
  include(TestHeaders)

  file(GLOB_RECURSE RANGE_V3_PUBLIC_HEADERS
                    RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/include"
                    "${CMAKE_CURRENT_SOURCE_DIR}/include/*.hpp")
  # This header is not meant to be included directly:
  list(REMOVE_ITEM RANGE_V3_PUBLIC_HEADERS std/detail/associated_types.hpp)
  # Deprecated headers
  if(CMAKE_CXX_COMPILER_ID STREQUAL GNU)
    foreach(header ${RANGE_V3_PUBLIC_HEADERS})
      file(STRINGS "${CMAKE_CURRENT_SOURCE_DIR}/include/${header}" is_deprecated
           LIMIT_COUNT 1
           REGEX ".*RANGES_DEPRECATED_HEADER.*")
      if(is_deprecated)
        list(APPEND RANGE_V3_DEPRECATED_PUBLIC_HEADERS "${header}")
      endif()
    endforeach()
  endif()

  add_header_test(test.range.v3.headers
    EXCLUDE ${RANGE_V3_DEPRECATED_PUBLIC_HEADERS}
    HEADERS ${RANGE_V3_PUBLIC_HEADERS})
  target_link_libraries(test.range.v3.headers PRIVATE range-v3)
endif()

# Grab the range-v3 version numbers:
include(${CMAKE_CURRENT_SOURCE_DIR}/Version.cmake)
set(RANGE_V3_VERSION ${RANGE_V3_MAJOR}.${RANGE_V3_MINOR}.${RANGE_V3_PATCHLEVEL})

# Try to build a new version.hpp
configure_file(version.hpp.in include/range/v3/version.hpp @ONLY)
file(STRINGS ${CMAKE_CURRENT_BINARY_DIR}/include/range/v3/version.hpp RANGE_V3_OLD_VERSION_HPP)
file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/include/range/v3/version.hpp RANGE_V3_NEW_VERSION_HPP)

# If the new version.hpp is materially different from the one in the source
# directory, update it, commit, and tag.
if(NOT RANGE_V3_NEW_VERSION_HPP STREQUAL RANGE_V3_OLD_VERSION_HPP)
  # Check that README.md and Version.cmake are the only changed file:
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" status --porcelain -uno
    OUTPUT_VARIABLE RANGE_V3_GIT_STATUS
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
  string(REPLACE "\n" ";"  RANGE_V3_GIT_STATUS ${RANGE_V3_GIT_STATUS})
  if (NOT "x${RANGE_V3_GIT_STATUS}" STREQUAL "x M Version.cmake; M doc/release_notes.md")
    message(FATAL_ERROR "Cannot update version.hpp: range-v3 source directory has a dirty status")
  endif()
  file(
    COPY ${CMAKE_CURRENT_BINARY_DIR}/include/range/v3/version.hpp
    DESTINATION ${CMAKE_CURRENT_SOURCE_DIR}/include/range/v3
  )
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" add -u
  )
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" commit -m "${RANGE_V3_VERSION}"
  )
  execute_process(
    COMMAND ${GIT_EXECUTABLE} -C "${CMAKE_CURRENT_SOURCE_DIR}" tag -f -a "${RANGE_V3_VERSION}" -m "${RANGE_V3_VERSION}"
  )
  find_program(CONAN_EXECUTABLE NAMES conan conan.exe)
  if (NOT "x${CONAN_EXECUTABLE}" STREQUAL "xCONAN_EXECUTABLE-NOTFOUND")
    message(STATUS "Exporting conanfile for new version")
    execute_process(
      COMMAND ${CONAN_EXECUTABLE} create . range-v3/${RANGE_V3_VERSION}@ericniebler/stable
      WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
    )
  endif()
  message(STATUS "Version updated to ${RANGE_V3_VERSION}. Don't forget to:")
  message(STATUS "  git push origin <feature-branch>")
  message(STATUS "and (after that is merged to master) then:")
  message(STATUS "  conan create ${CMAKE_CURRENT_SOURCE_DIR} range-v3/${RANGE_V3_VERSION}@ericniebler/stable")
  message(STATUS "  conan upload --all range-v3/${RANGE_V3_VERSION}@ericniebler/stable")
endif()

include(CMakePackageConfigHelpers)

# write_basic_package_version_file(...) gained ARCH_INDEPENDENT in CMake 3.14.
# For CMake 3.6, this workaround makes the version file ARCH_INDEPENDENT
# by making CMAKE_SIZEOF_VOID_P empty.
set(OLD_CMAKE_SIZEOF_VOID_P ${CMAKE_SIZEOF_VOID_P})
set(CMAKE_SIZEOF_VOID_P "")
write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/range-v3-config-version.cmake
  VERSION ${RANGE_V3_VERSION}
  COMPATIBILITY ExactVersion
)
set(CMAKE_SIZEOF_VOID_P ${OLD_CMAKE_SIZEOF_VOID_P})

install(TARGETS concepts meta range-v3 EXPORT range-v3-targets DESTINATION lib)
install(EXPORT range-v3-targets FILE range-v3-config.cmake DESTINATION lib/cmake/range-v3)
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/range-v3-config-version.cmake
  DESTINATION lib/cmake/range-v3)
install(DIRECTORY include/ DESTINATION include FILES_MATCHING PATTERN "*")

export(EXPORT range-v3-targets FILE range-v3-config.cmake)

=== example/CMakeLists.txt ===
set(CMAKE_FOLDER "example")

# examples use a less draconian set of compiler warnings
ranges_append_flag(RANGES_HAS_WNO_MISSING_BRACES -Wno-missing-braces)
ranges_append_flag(RANGES_HAS_WNO_SHORTEN_64_TO_32 -Wno-shorten-64-to-32)
ranges_append_flag(RANGES_HAS_WNO_GLOBAL_CONSTRUCTORS -Wno-global-constructors)

rv3_add_test(example.comprehensions comprehensions comprehensions.cpp)
rv3_add_test(example.hello hello hello.cpp)
rv3_add_test(example.count count count.cpp)
rv3_add_test(example.count_if count_if count_if.cpp)
rv3_add_test(example.any_all_none_of any_all_none_of any_all_none_of.cpp)
rv3_add_test(example.for_each_sequence for_each_sequence for_each_sequence.cpp)
rv3_add_test(example.for_each_assoc for_each_assoc for_each_assoc.cpp)
rv3_add_test(example.is_sorted is_sorted is_sorted.cpp)
rv3_add_test(example.find find find.cpp)
rv3_add_test(example.filter_transform filter_transform filter_transform.cpp)
rv3_add_test(example.accumulate_ints accumulate_ints accumulate_ints.cpp)
rv3_add_test(example.comprehension_conversion comprehension_conversion comprehension_conversion.cpp)
rv3_add_test(example.sort_unique sort_unique sort_unique.cpp)

# Guarded with a variable because the calendar example causes gcc to puke.
if(RANGES_BUILD_CALENDAR_EXAMPLE)
    set(Boost_USE_STATIC_LIBS        ON)
    set(Boost_USE_MULTITHREADED     OFF)
    set(Boost_USE_STATIC_RUNTIME    OFF)
    find_package(Boost 1.59.0 COMPONENTS date_time program_options)

    if (Boost_FOUND)
        add_executable(calendar calendar.cpp)
        target_include_directories(calendar SYSTEM PRIVATE ${Boost_INCLUDE_DIRS})
        target_link_libraries(calendar range-v3 ${Boost_LIBRARIES})
        message(STATUS "boost: ${Boost_LIBRARY_DIRS}")
        target_compile_definitions(calendar PRIVATE BOOST_NO_AUTO_PTR)
        target_compile_options(calendar PRIVATE -std=gnu++14)
        set_target_properties(calendar PROPERTIES LINK_FLAGS "-L${Boost_LIBRARY_DIRS}")
    endif()
endif()

=== test/algorithm/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,7 @@
+set(CMAKE_FOLDER "${CMAKE_FOLDER}/algorithm")
+
 rv3_add_test(test.alg.adjacent_find alg.adjacent_find adjacent_find.cpp)
+rv3_add_test(test.alg.adjacent_remove_if alg.adjacent_remove_if adjacent_remove_if.cpp)
 rv3_add_test(test.alg.all_of alg.all_of all_of.cpp)
 rv3_add_test(test.alg.any_of alg.any_of any_of.cpp)
 rv3_add_test(test.alg.none_of alg.none_of none_of.cpp)
@@ -7,6 +10,7 @@
 rv3_add_test(test.alg.copy_backward alg.copy_backward copy_backward.cpp)
 rv3_add_test(test.alg.count alg.count count.cpp)
 rv3_add_test(test.alg.count_if alg.count_if count_if.cpp)
+rv3_add_test(test.alg.ends_with alg.ends_with ends_with.cpp)
 rv3_add_test(test.alg.equal alg.equal equal.cpp)
 rv3_add_test(test.alg.equal_range alg.equal_range equal_range.cpp)
 rv3_add_test(test.alg.fill alg.fill fill.cpp)
@@ -99,6 +103,7 @@
 rv3_add_test(test.alg.sort_heap alg.sort_heap sort_heap.cpp)
 rv3_add_test(test.alg.stable_partition alg.stable_partition stable_partition.cpp)
 rv3_add_test(test.alg.stable_sort alg.stable_sort stable_sort.cpp)
+rv3_add_test(test.alg.starts_with alg.starts_with starts_with.cpp)
 rv3_add_test(test.alg.swap_ranges alg.swap_ranges swap_ranges.cpp)
 rv3_add_test(test.alg.transform alg.transform transform.cpp)
 rv3_add_test(test.alg.unique alg.unique unique.cpp)

=== test/view/CMakeLists.txt ===
--- 
+++ 
@@ -1,30 +1,43 @@
+set(CMAKE_FOLDER "${CMAKE_FOLDER}/view")
+
+rv3_add_test(test.view.adaptor view.adaptor adaptor.cpp)
+rv3_add_test(test.view.addressof view.addressof addressof.cpp)
 rv3_add_test(test.view.adjacent_remove_if view.adjacent_remove_if adjacent_remove_if.cpp)
 rv3_add_test(test.view.all view.all all.cpp)
 rv3_add_test(test.view.any_view view.any_view any_view.cpp)
-rv3_add_test(test.view.bounded view.bounded bounded.cpp)
+rv3_add_test(test.view.common view.common common.cpp)
 rv3_add_test(test.view.cartesian_product view.cartesian_product cartesian_product.cpp)
 rv3_add_test(test.view.chunk view.chunk chunk.cpp)
 rv3_add_test(test.view.concat view.concat concat.cpp)
 rv3_add_test(test.view.const view.const const.cpp)
+rv3_add_test(test.view.conversion view.conversion conversion.cpp)
 rv3_add_test(test.view.counted view.counted counted.cpp)
 rv3_add_test(test.view.cycle view.cycle cycle.cpp)
 rv3_add_test(test.view.delimit view.delimit delimit.cpp)
 rv3_add_test(test.view.drop view.drop drop.cpp)
 rv3_add_test(test.view.drop_exactly view.drop_exactly drop_exactly.cpp)
 rv3_add_test(test.view.drop_while view.drop_while drop_while.cpp)
+rv3_add_test(test.view.drop_last view.drop_last drop_last.cpp)
+rv3_add_test(test.view.enumerate view.enumerate enumerate.cpp)
 rv3_add_test(test.view.exclusive_scan view.exclusive_scan exclusive_scan.cpp)
+rv3_add_test(test.view.facade view.facade facade.cpp)
 rv3_add_test(test.view.generate view.generate generate.cpp)
 rv3_add_test(test.view.generate_n view.generate_n generate_n.cpp)
+rv3_add_test(test.view.getlines view.getlines getlines.cpp)
 rv3_add_test(test.view.group_by view.group_by group_by.cpp)
 rv3_add_test(test.view.indirect view.indirect indirect.cpp)
 rv3_add_test(test.view.intersperse view.intersperse intersperse.cpp)
 rv3_add_test(test.view.iota view.iota iota.cpp)
+rv3_add_test(test.view.istream view.istream istream.cpp)
+rv3_add_test(test.view.iterator_range view.iterator_range iterator_range.cpp)
 rv3_add_test(test.view.join view.join join.cpp)
 rv3_add_test(test.view.linear_distribute view.linear_distribute linear_distribute.cpp)
 rv3_add_test(test.view.map view.map keys_value.cpp)
 rv3_add_test(test.view.move view.move move.cpp)
 rv3_add_test(test.view.partial_sum view.partial_sum partial_sum.cpp)
+# rv3_add_test(test.view.partial_sum_depr view.partial_sum_depr partial_sum_depr.cpp)
 rv3_add_test(test.view.repeat view.repeat repeat.cpp)
+rv3_add_test(test.view.remove view.remove remove.cpp)
 rv3_add_test(test.view.remove_if view.remove_if remove_if.cpp)
 rv3_add_test(test.view.replace view.replace replace.cpp)
 rv3_add_test(test.view.replace_if view.replace_if replace_if.cpp)
@@ -36,13 +49,20 @@
 rv3_add_test(test.view.set_union view.set_union set_union.cpp)
 rv3_add_test(test.view.slice view.slice slice.cpp)
 rv3_add_test(test.view.sliding view.sliding sliding.cpp)
+rv3_add_test(test.view.span view.span span.cpp)
 rv3_add_test(test.view.split view.split split.cpp)
 rv3_add_test(test.view.stride view.stride stride.cpp)
+rv3_add_test(test.view.subrange view.subrange subrange.cpp)
 rv3_add_test(test.view.tail view.tail tail.cpp)
 rv3_add_test(test.view.take view.take take.cpp)
 rv3_add_test(test.view.take_exactly view.take_exactly take_exactly.cpp)
+rv3_add_test(test.view.take_last view.take_last take_last.cpp)
 rv3_add_test(test.view.take_while view.take_while take_while.cpp)
 rv3_add_test(test.view.tokenize view.tokenize tokenize.cpp)
 rv3_add_test(test.view.transform view.transform transform.cpp)
+rv3_add_test(test.view.trim view.trim trim.cpp)
 rv3_add_test(test.view.unique view.unique unique.cpp)
+rv3_add_test(test.view.view view.view view.cpp)
 rv3_add_test(test.view.zip view.zip zip.cpp)
+
+target_compile_definitions(view.iterator_range PRIVATE RANGES_DISABLE_DEPRECATED_WARNINGS)

=== debian/changelog ===
range-v3 (0.9.1-1~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Sat, 19 Oct 2019 13:04:58 -0700

range-v3 (0.9.1-1) unstable; urgency=medium

  * New upstream release.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Wed, 04 Sep 2019 00:04:35 +0300

range-v3 (0.9.0-1~exp1) experimental; urgency=medium

  * New upstream release.
    - Fixes FTBFS with GCC 9 (closes: #934838).
    - Removes support of C++11.
  * New build dependency, Boost, to build the calendar example.
  * Delete Check-Wno-flags.patch as applied by upstream.
  * Remove workaround with -Wno-error=maybe-uninitialized.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 31 Aug 2019 09:46:13 +0300

range-v3 (0.5.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump debhelper compatibility level to 12, no related changes.
  * Bump standards version to 4.4.0, no related changes.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Fri, 02 Aug 2019 17:17:56 +0300

=== debian/control ===
Source: range-v3
Section: libdevel
Priority: optional
Maintainer: Steven Pusser <stevep@mxlinux.org>
XSBC-Original-Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (= 12)
Build-Depends-Indep:
 cmake (>= 3.6.0),
 doxygen (>= 1.8.13) <!nodoc>,
 doxygen-latex (>= 1.8.13) <!nodoc>,
 libboost-date-time-dev (>= 1.59.0) <!nocheck>,
 libboost-program-options-dev (>= 1.59.0) <!nocheck>,
Standards-Version: 4.4.0
Rules-Requires-Root: no
Homepage: https://github.com/ericniebler/range-v3
Vcs-Git: https://salsa.debian.org/debian/range-v3.git
Vcs-Browser: https://salsa.debian.org/debian/range-v3

Package: librange-v3-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: librange-v3-doc
Description: range algorithms, views, and actions for C++14/17/20 - headers
 Range-v3 is a generic library that augments the existing standard library with
 facilities for working with ranges. A range can be loosely thought of a pair
 of iterators. This library provides a full implementation of all the standard
 algorithms with range-based overloads for convenience.
 .
 This package contains headers of the library.

Package: librange-v3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: range algorithms, views, and actions for C++14/17/20 - documentation
 Range-v3 is a generic library that augments the existing standard library with
 facilities for working with ranges. A range can be loosely thought of a pair
 of iterators. This library provides a full implementation of all the standard
 algorithms with range-based overloads for convenience.
 .
 This package ships HTML documentation of the library.
